// ufo modoki sample 1. use POV-Ray 3.7
//
// +W512 +H512 +a0.3 +KFF20 +KC +UA
//
// width=512 height=512 Antialias_Threshold=0.3 Antialias=on 
// Final_Frame=20 Cyclic_Animation=on
// Output_Alpha=on
// 
// Requirement : GALAXY.INC
//
// POV-Ray Include Files Page
// https://web.archive.org/web/20091018195703/http://geocities.com/SiliconValley/Lakes/1434/

#include "colors.inc"
#include "textures.inc"
#include "shapes.inc"
#include "stones.inc"
#include "metals.inc"
#include "golds.inc"
#include "glass.inc"
#include "skies.inc"

#declare galaxy_seed = 541;
#include "GALAXY.INC"

camera {
  location <0, 0, -2.6>
  look_at <0, 0, 0>
  angle 45
  right x*image_width/image_height
}

light_source { <-4, 8, -6> color rgb 1.5 }
light_source { <12, 7, -8> color rgb <0.3, 0.8, 0.5> }
light_source { <-15, -24, -3> color rgb <0.1, 0.5, 0.7> }

#declare lz = 1.1;
// light_source { <0, 0, -lz> color rgb <1, 0.25, 0> }
// light_source { <0, 0, lz> color rgb <1, 0.25, 0> }

#declare myBodyTex = T_Silver_4E;
// #declare myBodyTex = Aluminum;
// #declare myBodyTex = Chrome_Texture;
// #declare myBodyTex = Brushed_Aluminum;
// #declare myBodyTex = Polished_Chrome;
// #declare myBodyTex = Soft_Silver;
// #declare myBodyTex = Silver_Texture;

#declare myBlackTex = pigment { color rgb 0.025 };
// #declare myBlackTex = T_Chrome_2B;

// #declare myBlackTex2 = pigment { color rgb 0.2 };
// #declare myBlackTex2 = T_Chrome_2B;
// #declare myBlackTex2 = Gold_Nugget;
// #declare myBlackTex2 = Polished_Chrome;
#declare myBlackTex2 = myBodyTex;

#declare holer = 0.55;

#declare a = 0.02;

union {
  difference {
    difference {
      sphere {
        <0, 0, 0>, 1
        texture {
          myBodyTex
        }
        scale <1, 1, 0.4>
        translate <0, 0, 0>
      }
    
      box { <-1, -0.1, -a>, <1, 0.1, -2.0> texture { myBlackTex2 } }
      box { <-0.1, -1, -a>, <0.1, 1, -2.0> texture { myBlackTex2 } }
      box { <-1, -0.1, a>, <1, 0.1, 2.0> texture { myBlackTex2 } }
      box { <-0.1, -1, a>, <0.1, 1, 2.0> texture { myBlackTex2 } }
    }
      
    cylinder { <0, 0, -0.01>, <0, 0, -2.0>, holer texture { myBlackTex } }
    cylinder { <0, 0,  0.01>, <0, 0,  2.0>, holer texture { myBlackTex } }
    
    #declare i = 0;
    #while (i < 360)
      object {
        box {
          <0, -0.09, -1>,
          <0.16,  0.09, 1>
          texture { myBlackTex }
        }
        translate <0.89, 0, 0>
        rotate <0, 0, i>
      }
      #declare i = i + (360/12);
    #end
  }
  
  sphere {
    <0, 0, 0> 0.45
    // material { M_Ruby_Glass }
    texture {
      pigment { color rgb <1, 0.05, 0.0> }
      finish {
        phong 1
        phong_size 150
        specular 0.3
        roughness 0.0025
        reflection 0.2
        metallic 0.0
      }
    }
    scale <1, 1, 1>
    translate <0, 0, 0>
  }

  /*  
  sphere {
    <0, 0, 0> 0.41
    material { M_Orange_Glass }
  }
  */
  
  rotate <0, 0, 90 * clock>
}



// sky_sphere { S_Cloud5 rotate <180, 0, 0> }

/*
object {
  Plane_XZ
  texture {
    pigment {
      checker color rgb 0, color rgb 1
    }
    finish {
      phong 0.2
      reflection 0.3
    }
  }
  translate <0, -10, 0>
}
*/
